;************************************************************************/
;*																		*/
;*					Zweipunktregelung CO2- Magnetventil 				*/
;*                                                                      */
;*              	Author: Raik Apelt                                  */
;*                                                                      */
;************************************************************************/
;
; ph0
; ph4
; 			Zone3
;
; ph 6,48	Magnetventil Aus
;
; 			Zone2 -> Magnetventil behlt seinen Betriebszustand
;
; ph 6,87	Magnetventil An
;
; 			Zone1
; ph7
; ph12

.CSEG
Regelung:	ldi ZH, high(_WertMV_An)
			ldi ZL, low(_WertMV_An)	; Adresse des Schaltwertes MV An von EEPROM laden
			rcall EEPROM_Read		; aus EEPROM Schaltwert lesen (R2 - high(Wert) / R1 - low(Wert))
			lds R3, WertL
			lds R4, WertH
			cp R1, R3
			cpc R2, R4
			brcs Zone1
			ldi ZH, high(_WertMV_Aus)
			ldi ZL, low(_WertMV_Aus)	; Adresse des Schaltwertes MV Aus von EEPROM laden
			rcall EEPROM_Read			; aus EEPROM Schaltwert lesen (R2 - high(Wert) / R1 - low(Wert))
			lds R3, WertL
			lds R4, WertH
			cp R1, R3
			cpc R2, R4
			brcs Zone2
			ldi ZH, high(_WertMV_Aus)
			ldi ZL, low(_WertMV_Aus)	; Adresse des Schaltwertes MV Aus von EEPROM laden
			rcall EEPROM_Read			; aus EEPROM Schaltwert lesen (R2 - high(Wert) / R1 - low(Wert))
			lds R3, WertL
			lds R4, WertH
			cp R1, R3
			cpc R2, R4
			cbi out_port, MV		; Zone 3 - Bit MV in out_port auf 0 setzen / MV Aus
			ret			

Zone1:		sbi out_port, MV	 	; Bit MV in out_port auf 1 setzen / MV An
			ret
Zone2:		ret
