;********************************************************************************************
;* Intro-Sub-Routine fr LCD-Anzeigen beim Bootvorgang aus EE-PROM des AVR	(16bit-Adresse) *
;********************************************************************************************

; Diese Sub-Routine wird nach dem Einschalten kurz abgearbeitet und damit die Intro-Texte
; aus dem EE-PROM angezeigt.
; Die Basisroutine fr die LCD-Anzeige LCD_Basisroutine.asm mu mit im Hauptprogramm 
; eingebunden und initialisiert sein.
; Auerdem mu das Register R0 als Zwischenspeicher frei verwendbar sein.

.EQU warten=3 						; Konstante fr Anzeigezeit des Intros (warten * 1s)
.CSEG
Intro:  ldi rmp,0x84 				; Curser verschieben in 1.Zeile 5.Zeichen in LCD
		rcall Lcd4Ctrl

        ldi ZH, high(introtext1)
		ldi ZL, low(introtext1)     ; Adresse des introtext1 von EEPROM laden
		rcall LcdEepPrint			; Unterfunktion LcdEepPrint aufrufen

		ldi rmp,0xC1 				; Curser verschieben in 2.Zeile 2.Zeichen in LCD
		rcall Lcd4Ctrl

		ldi ZH, high(introtext2)
		ldi ZL, low(introtext2)    	; Adresse des introtext2 von EEPROM laden
		rcall LcdEepPrint           ; Unterfunktion LcdEepPrint aufrufen

; Verzgerung um int Sekunden zur Anzeige des Intros

IntDelay:
		   ldi rmp,warten		; warten * 1s warten
IntDelay1:
		   push rmp 			; Rette Byte auf Stapel
		   rcall LcdDelay1s		; Routine wird aus LCD_Basisroutine.asm aufgerufen
		   pop rmp 				; Stelle Byte wieder her
		   dec rmp
		   brne IntDelay1
		
		   rcall Lcd4Clear		; LCD-Anzeige lschen
		   
		   ret					; Ende der Funktion und Rcksprung

.eseg                           ; EEPROM-Segment aktivieren
introtext1:
.db "apelt_de@", 0				; Introtext 1 im EEPROM terminiert mit 0
introtext2:
.db "yahoo.de  2008", 0			; Introtext 2 im EEPROM terminiert mit 0
