; DCF77-FUNKUHR BAUSTEIN in AVR Assembler nach Peter Dannegger
;
;Voraussetzungen: ftakt - Wert fr Systemtakt mu gesetzt sein
;				  Register 15/20...25 mssen unbenutzt sein
;				  Register rmp/work >=R16 mssen definiert sein
;				  Register R0..R10 werden temporr benutzt 
;
; Das DCF77-Signal wird mit Aktiv "Low" an Input PD2 erwartet
; (kann frei nach Bedarf angepasst werden).
.equ DCFPORT = PIND;
.equ DCFPIN = 2;
;
;.def	reload		= R12
;.def	delta		= R13
.def	prescaler	= R15
;
.def	flags 		= R20
.equ	Dcf77value	= 0		; must be 0 !
.equ	Dcf77pulse	= 1		; must be 1 !
.equ	Dcf77Input	= 2
.equ	dcf77sync	= 3
.equ	Dcf77Parity = 4
.equ	Dcf77Error 	= 5
.equ	second1		= 6		; 1 Sekunde vergangen

.def	dcf77time	= R21
.def	sum 		= R22
.def	newsecond	= R23
.def	c0			= R24	; Register <R16 benutzbar
.def	c1			= R25	; Register <R16 benutzbar
;
;SRAM Variable 							Beschreibung
;------------------------------------------------------------
.equ AddrNewMinute	= $80				; 0x0080 Adresse im SRAM von newminute
										; -> Variablen im SRAM zusammen lassen
.equ newminute	= AddrNewMinute		    ; RTC verwaltet	Minute
.equ newhour	= AddrNewMinute + 1		; RTC verwaltet	Stunde
.equ newday		= AddrNewMinute + 2		; RTC verwaltet	Tag
.equ newweekday	= AddrNewMinute + 3		; RTC verwaltet	Wochentag
.equ newmonth	= AddrNewMinute + 4		; RTC verwaltet	Monat
.equ newyear	= AddrNewMinute + 5		; RTC verwaltet	Jahr

.equ SEK		= AddrNewMinute + 6		; RTC verwaltet	BCD Sekunde
.equ MIN		= AddrNewMinute + 7		; RTC verwaltet	BCD Minute
.equ STU		= AddrNewMinute + 8		; RTC verwaltet	BCD Stunde
.equ TAG		= AddrNewMinute + 9		; RTC verwaltet	BCD Tag
.equ WTAG		= AddrNewMinute + 10	; RTC verwaltet	BCD Wochentag
.equ MON		= AddrNewMinute + 11	; RTC verwaltet	BCD Monat
.equ JHR		= AddrNewMinute + 12	; RTC verwaltet	BCD Jahr

; SRAM-Speicerbereich fr Ausgabe Uhrzeit mittels Z-Pointer
.equ StuH		= AddrNewMinute + 13	; RTC verwaltet	ASCII StundeH
.equ StuL		= AddrNewMinute + 14	; RTC verwaltet	ASCII StundeL
.equ TrennerStu	= AddrNewMinute + 15	; Trennzeichen Stundenanzeige		
.equ MinH		= AddrNewMinute + 16	; RTC verwaltet	ASCII MinuteH
.equ MinL		= AddrNewMinute + 17	; RTC verwaltet	ASCII MinuteL
.equ TrennerMin	= AddrNewMinute + 18	; Trennzeichen Minutenanzeige
.equ SekH		= AddrNewMinute + 19	; RTC verwaltet	ASCII SekundeH
.equ SekL		= AddrNewMinute + 20	; RTC verwaltet	ASCII SekundeL
.equ TagH		= AddrNewMinute + 21	; RTC verwaltet	ASCII TagH
.equ TagL		= AddrNewMinute + 22	; RTC verwaltet	ASCII TagL
.equ TrennerTag	= AddrNewMinute + 23	; Trennzeichen Taganzeige
.equ MonH		= AddrNewMinute + 24	; RTC verwaltet	ASCII MonatH
.equ MonL		= AddrNewMinute + 25	; RTC verwaltet	ASCII MonatL
.equ TrennerMon	= AddrNewMinute + 26	; Trennzeichen Monatsanzeige
.equ JhrH		= AddrNewMinute + 27	; RTC verwaltet	ASCII JahrH
.equ JhrL		= AddrNewMinute + 28	; RTC verwaltet	ASCII JahrH

; Variablen interner RC- Timer
.equ delta		= AddrNewMinute + 29
.equ reload		= AddrNewMinute + 30
;.equ c0			= AddrNewMinute + 31	; -> mit 0 initialisieren
;.equ c1			= AddrNewMinute + 32	; -> mit 0 initialisieren

.equ reload1sec = (ftakt / 256 + 128) / 256	; Teiler 256 im Timer

.equ	minpulse		= reload1sec * 5 / 100		;50ms
.equ	pulselowhigh	= reload1sec * 15 / 100		;150ms
.equ	maxpulse		= reload1sec * 25 / 100		;250ms

.equ	min1sec			= reload1sec * 90 / 100		;0.9s
.equ	max1sec			= reload1sec * 110 / 100	;1.1s

.equ	min2sec			= reload1sec * 180 / 100	;1.8s
.equ	max2sec			= reload1sec * 220 / 100	;2.2s
;-------------------------------------------------------------------------


.CSEG
; Interruptroutine
TIMER_2:				; mglichst Timer hchster Prioritt verwenden
		push rmp		; Arbeitsregister sichern
		in	rmp, sreg	; Statusregister holen
		push rmp		; Statusregister sichern
		push work		; Arbeitsregister sichern
		
		;lds work, c0
		;inc work
		inc c0				;pulses per minute
		brne _tov1
		;lds rmp, c1
		;inc rmp
		;sts c1, rmp
		inc c1
_tov1:
		dec prescaler		;count down prescaler
		brne _tov3
		sbr flags, 1<<second1
		lds rmp, reload		;reload prescaler
		mov prescaler, rmp
;		mov prescaler, reload	
		lds rmp, delta
		add sum, rmp
;		add sum, delta
		brcc _tov3
		subi sum, 60
		inc prescaler			;fine adjustment
_tov3:
		cpi dcf77time, 1
		sbci dcf77time, -1		;count: 1,2...fe,ff,00,00

		bst flags, dcf77input
		sbis dcfport, dcfpin	;DCF77 input pin
		rjmp _tov5
		brtc _tov8
		cbr flags, 1<<dcf77input	;0->1 transition

		subi dcf77time, minpulse
		cpi dcf77time, maxpulse - minpulse
		brcs _tov4
		sbr flags, 1<<dcf77error				; error
_tov4:	cpi dcf77time, pulselowhigh - minpulse	;pulse length
		sbci flags, -3
		subi dcf77time, -minpulse
		rjmp _tov8

_tov5:	brts _tov8
		sbr flags, 1<<dcf77input		;1->0 transition

		subi dcf77time, min1sec
		cpi dcf77time, max1sec - min1sec
		brcs _tov7						; 1 second

		subi dcf77time, min2sec - min1sec
		cpi dcf77time, max2sec - min2sec
		brcs _tov6
		sbr	flags, 1<<dcf77error		; error
_tov6:	sbr	flags, 1<<dcf77sync			; 2 second
_tov7:	ldi	dcf77time, 1

_tov8:	;sts c0, work
		pop work		; Arbeitsregister zurckschreiben
		pop rmp			; Sicherkeitskopie Statusregister holen
		out sreg, rmp	; Sicherkeitskopie Statusregister zurckschreiben
		pop rmp			; Arbeitsregister zurckschreiben
		reti			; zurck aus Interrupt und erneute Freigabe Interrupts

; Funkuhrmodul dcf77 initialisieren
_dcf77init:
		; Calibrierung vom Flash lesen (nur bei Verwendung des internen RC- Oscillators)
		ldi	zl, low( 2 * calbyte )
		ldi	zh, high( 2 * calbyte )
		lpm					
		out	osccal, r0
		;lds r1, 0xFF
		;ldi zl, low( 2 * flashend)  ;Adresse auf Kalibrationsbyte L
 		;ldi zh, high( 2 * flashend) ;und H
		;spm 						; Calibrierung fr spter speichern -> funktioniert nicht
		; Speicherzellen SRAM initialisieren
		clr rmp
		sts newminute, rmp
		sts newhour, rmp
		sts newday, rmp
		sts newweekday, rmp
		sts newmonth, rmp
		sts newyear, rmp
		sts SEK, rmp
		sts MIN, rmp
		sts STU, rmp
		sts WTAG, rmp
		;sts c0, rmp
		;sts c1, rmp
		ldi rmp, 1
		sts TAG, rmp
		sts MON, rmp
		ldi rmp, 8
		sts JHR, rmp
		ldi rmp, ':'
		sts TrennerStu, rmp
		sts TrennerMin, rmp
		ldi rmp, '.'
		sts TrennerTag, rmp
		sts TrennerMon, rmp
		; Auswertung initialisieren
		ldi rmp, reload1sec
		sts reload, rmp
;		mov reload, rmp
		ldi rmp, 59
		sts delta, rmp
;		mov delta, rmp
		ret

; Routine zur Errechnung der Zeit- und Kalenderdaten
_clock_inc4:			; Rcksprungmarke oben, da sonst Fehlermeldung zu relativen Sprngen
	ret
clock_inc:
	lds rmp, SEK
	inc	rmp
	sts	SEK, rmp
	cpi	rmp, 60
	brcs _clock_inc4
	clr rmp
	sts	SEK, rmp
	lds rmp, MIN
	inc	rmp
	sts	MIN, rmp
	cpi	rmp, 60
	brcs _clock_inc4
	clr rmp
	sts	MIN, rmp
	lds rmp, STU
	inc	rmp
	sts	STU, rmp
	cpi	rmp, 24
	brcs _clock_inc4
	clr rmp
	sts	STU, rmp
	lds rmp, TAG
	inc	rmp
	sts TAG, rmp
	lds rmp, WTAG
	inc	rmp
	sts WTAG, rmp
	cpi	rmp, 8
	brcs _clock_inc1
	ldi rmp, 1
	sts WTAG, rmp
_clock_inc1:
	ldi	work, 30			; 30 Tage-Monate
	lds rmp, MON
	cpi	rmp, 4
	breq _clock_inc2
	cpi	rmp, 6
	breq _clock_inc2
	cpi	rmp, 9
	breq _clock_inc2
	cpi	rmp, 11
	breq _clock_inc2
	ldi	work, 31			; 31 Tage-Monate
	cpi	rmp, 2
	brne _clock_inc2		; nur im Februar gltig
	ldi	work, 29			; 29 Tage im Schaltjahr
	lds rmp, JHR
	sbrs rmp, 0
	sbrc rmp, 1
	ldi	work, 28			; 28 Tage restliche Monate im Jahr
_clock_inc2:
	lds rmp, TAG
	cp	work, rmp
	brcc _clock_inc3
	ldi rmp, 1
	sts	TAG, rmp
	lds rmp, MON
	inc	rmp
	sts MON, rmp
	cpi	rmp, 13
	brcs _clock_inc3
	ldi rmp, 1
	sts MON, rmp
	lds rmp, JHR
	inc	rmp
	sts JHR, rmp
	cpi	rmp, 100
	brcs _clock_inc3
	clr rmp
	sts JHR, rmp
_clock_inc3:
	ret

; Umwandlung der Uhrzeit/Datum von BCD-RTC zu ASCII-Uhrzeit/Datum
RtcConv:
	lds rmp, SEK
	mov R1, rmp
	rcall BcdConv
	sts SekH, R3
	sts SekL, R4
	lds rmp, MIN
	mov R1, rmp
	rcall BcdConv
	sts MinH, R3
	sts MinL, R4
	lds rmp, STU
	mov R1, rmp
	rcall BcdConv
	sts StuH, R3
	sts StuL, R4
	lds rmp, TAG
	mov R1, rmp
	rcall BcdConv
	sts TagH, R3
	sts TagL, R4
	lds rmp, MON
	mov R1, rmp
	rcall BcdConv
	sts MonH, R3
	sts MonL, R4
	lds rmp, JHR
	mov R1, rmp
	rcall BcdConv
	sts JhrH, R3
	sts JhrL, R4
	ret

; Umwandlung BCD-Zahl in ASCII-Zeichen (zweistellige Zahlen)
; R1 - zu wandelnde BCD-Zahl
; R2 - Teiler
; R3 - Zehnerzeichen
; R4 - Einerzeichen
BcdConv:
	ldi rmp,10 		; Setze Dezimalteiler auf 10
	mov R2,rmp
	rcall BcdConv10d ; Hole die nchste Ziffer
	mov R3,rmp 		; Setze Zehner Zeichen
	ldi rmp,'0' 	; Wandle Rest in ASCII-Ziffer um
	add rmp,R1
	mov R4,rmp 		; Setze Einer Zeichen
	ret				; fertig

; Wandle Binrwort in R1 in eine Dezimalziffer durch fortgesetztes
; Abziehen des Dezimalteilers in R2 (10)
BcdConv10d:
	ldi rmp,'0' 	; Beginne mit ASCII-0
BcdConv10d1:
	cp R1,R2 		; Vergleiche Wort mit Teiler
	brcc BcdConv10d2 ; Carry nicht gesetzt, subtrahiere Teiler
	ret
BcdConv10d2:
	sub R1,R2 		; Subtrahiere Teilerwert
	inc rmp 		; Ziffer um eins erhhen
	rjmp BcdConv10d1

; Routine zur Decodierung der DFC77-Informationen

DecodeDcf77:
	clt
	sbrs flags, Dcf77sync		;second 00 detect
	rjmp _ddc2
	sbrc flags, Dcf77Error		;no Error
	rjmp _ddc1
	cpi	NewSecond, 59           ;right number of bits
	brne _ddc1

; Dividiert die Zhlung pro Minute /60 fr RC- Oscillator-Justierung
; Register zl / zh werden nur als Hilfsregister benutzt
	ldi zh, 16
	clr zl
_div1:
	;lds rmp, c0
	;lsl rmp
	;sts c0, rmp
	lsl c0
	;lds rmp, c1
	;rol rmp
	;sts c1, rmp
	rol c1
	rol zl
	cpi zl, 60
	brcs _div2
	subi zl, 60
	;lds rmp, c0
	;inc rmp
	;sts c0, rmp
	inc c0
_div2:
	dec zh
	brne _div1
	
	;lds rmp, c0
	;sts reload, rmp			;adjust internal RC timer
	sts reload, c0			;adjust internal RC timer
;	mov	reload, c0
	sts delta, zl			;fine adjust
;	mov	delta, zl
	;mov prescaler, rmp
	mov prescaler, c0
;	mov	prescaler, reload
;neue Zeit und Datum laden
	clr	rmp
	sts SEK, rmp
	lds rmp, NewMinute
	sts Min, rmp				
	lds rmp, NewHour
	sts Stu, rmp
	lds rmp, NewDay
	sts Tag, rmp
	lds rmp, NewWeekDay
	sts WTag, rmp
	lds	rmp, NewMonth
	sts Mon, rmp
	lds rmp, NewYear
	sts Jhr, rmp
	set					; Anzeige der neuen Uhrzeit / Datum durch Auswertung
						; des T-Flag im Hauptprogramm
_ddc1:
	;clr rmp
	;sts c0, rmp
	;sts c1, rmp
	clr c0
	clr c1
	ldi	NewSecond, 0
	cbr	flags, 1<<Dcf77Error^1<<dcf77sync^1<<dcf77parity
_ddc2:
	sbrs flags, dcf77pulse
	rjmp _ddc6

	mov	zl, NewSecond
	subi zl, 21
	cpi	zl, (Dcf77TableEnd - Dcf77Table) * 2	;only bit 21 .. 58
	brcc _ddc5

	ldi	rmp, 1<<dcf77parity
	sbrc flags, dcf77value
	eor	flags, rmp			;parity ^= pulse

	ldi	zh, 0
	add	zl, zl				; * 2
	subi zl, low(-(Dcf77Table * 2 + 1))
	sbci zh, high(-(Dcf77Table * 2 + 1))
	lpm						;get value to add
	mov	rmp, r0

	tst	rmp
	brne _ddc3
	sbrc flags, dcf77parity
	sbr	flags, 1<<dcf77error		;set error bit
	rjmp _ddc5
_ddc3:
	dec	zl
	lpm					;get byte address
	mov	zl, r0
	ld	r0, z
	cpi	rmp, 1			;test a0 = 1
	brne _ddc4
	clr	r0				;clear old value
_ddc4:
	sbrc flags, dcf77value
	add r0, rmp
	st z, r0
_ddc5:
	cbr flags, 1<<dcf77pulse^1<<dcf77value
	inc newsecond
	brne _ddc6
	sbr flags, 1<<dcf77error
_ddc6:
	ret

; Daten zur Decodierung des DCF77- Signals mittels Z- Register
; Aufbau = Speicherzelle (newminute,..) RTC, Wert RTC
Dcf77Table:
	.db	AddrNewMinute, 1		;minute
	.db	AddrNewMinute, 2
	.db	AddrNewMinute, 4
	.db	AddrNewMinute, 8
	.db	AddrNewMinute, 10
	.db	AddrNewMinute, 20
	.db	AddrNewMinute, 40
	.db	0, 0					;parity
	.db	AddrNewMinute + 1, 1	;hour
	.db	AddrNewMinute + 1, 2
	.db	AddrNewMinute + 1, 4
	.db	AddrNewMinute + 1, 8
	.db	AddrNewMinute + 1, 10
	.db	AddrNewMinute + 1, 20
	.db	0, 0					;parity
	.db	AddrNewMinute + 2, 1	;day
	.db	AddrNewMinute + 2, 2
	.db	AddrNewMinute + 2, 4
	.db	AddrNewMinute + 2, 8
	.db	AddrNewMinute + 2, 10
	.db	AddrNewMinute + 2, 20
	.db	AddrNewMinute + 3, 1	;weekday
	.db	AddrNewMinute + 3, 2
	.db	AddrNewMinute + 3, 4
	.db	AddrNewMinute + 4, 1	;month
	.db	AddrNewMinute + 4, 2
	.db	AddrNewMinute + 4, 4
	.db	AddrNewMinute + 4, 8
	.db	AddrNewMinute + 4, 10
	.db	AddrNewMinute + 5, 1	;year
	.db	AddrNewMinute + 5, 2
	.db	AddrNewMinute + 5, 4
	.db	AddrNewMinute + 5, 8
	.db	AddrNewMinute + 5, 10
	.db	AddrNewMinute + 5, 20
	.db	AddrNewMinute + 5, 40
	.db	AddrNewMinute + 5, 80
	.db	0, 0					;parity
Dcf77TableEnd:

calbyte:
.db 159, 0xFF					; Getestet bei U=5,002V und 25,0C -> RC= 8,000MHz
